These are the OP CODES for the instruction set of INTEL MCS-48 MPUs, which includes 8048s, 8040s, 8049s, 8038s, and 8050s. If you want to learn more than you could ever hope to use about these chips, get the INTEL "Embedded Controller Handbook, vol.1" from Jameco. (look in BYTE for their ads).00 NOP01*02 OUTL BUS,A  [typical format....OUTput Accumulator to the BUSs. Destination first, then Source.]03 ADD A,#data 2   [the trailing "2" signifies a 2 byte instruction. the "#data" is an immediate (follows the op code in memory) operand. this instruction, therefore, adds "#data" to the Accumulator.]04 JMP 0 2   [the "0" sets the 256 byte page that you want to jump into. note that this is a two byte instruction - the second byte specifies the low order portion of the jump-to address.]05 EN I    [special op - Enable Interrupts.]06*       [no operation defined for this value.]07 DEC A08 INS A,BUS09 IN A,P0    [INput Port 0 to the Accumulator. there are two general purpose ports, P0 and P1.0A IN A,P10B*0C MOVD A,P4    [these ports (4-7) require an extra chip.]0D MOVD A,P50E MOVD A,P60F MOVD A,P710 INC @R0    ["@R0" denotes an indirect address into data memory, using R0 as an address register. in 6502 terms, thus - INC ($82).]11 INC @R112 JB0 213 ADDC A,#data 214 CALL 0 215 DIS I16 JTF 217 INC A18 INC R019 INC R11A INC R21B INC R31C INC R41D INC R51E INC R61F INC R720 XCH A,@R021 XCH A,@R123 MOV A,#data 224 JMP 1 225 EN TCNTI26 JNT0 227 CLR A28 XCH A,R029 XCH A,R12A XCH A,R22B XCH A,R32C XCH A,R42D XCH A,R52E XCH A,R62F XCH A,R730 XCHD A,@R031 XCHD A,@R132 JB1 233*34 CALL 1 235 DIS TCNTI36 JT0 237 CPL A38*39 OUT P1,A3A OUT P2,A3B*3C MOVD P4,A3D MOVD P5,A3E MOVD P6,A3F MOVD P7,A40 ORL A,@R041 ORL A,@R142 MOV A,T43 ORL A,#data 244 JMP 2 245 STRT CNT46 JNT1 247 SWAP A48 ORL A,R049 ORL A,R14A ORL A,R24B ORL A,R34C ORL A,R44D ORL A,R54E ORL A,R64F ORL A,R750 ANL A,@R051 ANL A,@R152 JB2 253 ANL A,#data 254 CALL 2 255 STRT T56 JT1 257 DA A58 ANL A,R059 ANL A,R15A ANL A,R25B ANL A,R35C ANL A,R45D ANL A,R55E ANL A,R65F ANL A,R760 ADD A,@R061 ADD A,@R162 MOV T,A63*64 JMP 3 265 STOP TCNT66*67 RRC A68 ADD A,R069 ADD A,R16A ADD A,R26B ADD A,R36C ADD A,R46D ADD A,R56E ADD A,R66F ADD A,R770 ADDC A,@R071 ADDC A,@R172 JB3 273*74 CALL 3 275 ENT0 CLK76 JF1 277 RR A78 ADDC A,R079 ADDC A,R17A ADDC A,R27B ADDC A,R37C ADDC A,R47D ADDC A,R57E ADDC A,R67F ADDC A,R780 MOVX A,@R081 MOVX A,@R182*83 RET84 JMP 4 285 CLR F086 JNI 287*88 ORL BUS,#data 289 ORL P1,#data 28A ORL P2,#data 28C ORLD P4,A8D ORLD P5,A8E ORLD P6,A8F ORLD P7,A90 MOVX @R0,A91 MOVX @R1,A92 JB4 293 RETR    [return from a call (which is just a JSR).]94 CALL 4 295 CPL F096 JNZ 297 CLR C98 ANL BUS,#data 299 ANL P1,#data 29A ANL P2,#data 29B*9C ANLD P4,A9D ANLD P5,A9E ANLD P6,A9F ANLD P7,AA0 MOV @R0,AA1 MOV @R1,AA2*A3 MOVP A,@AA4 JMP 5 2A5 CLR F1A6*A7 CPL CA8 MOV R0,AA9 MOV R1,AAA MOV R2,AAB MOV R3,AAC MOV R4,AAD MOV R5,AAE MOV R6,AAF MOV R7,AB0 MOV @R0,#data 2B1 MOV @R1,#data 2B2 JB5 2B3 JMPP @AB4 CALL 5 2B5 CPL F1B6 JF0 2B7*B8 MOV R0,#data 2B9 MOV R1,#data 2BA MOV R2,#data 2BB MOV R3,#data 2BC MOV R4,#data 2BD MOV R5,#data 2BE MOV R6,#data 2BF MOV R7,#data 2C0*C1*C2*C3*C4 JMP 6 2C5 SEL RB0C6 JZ 2C7 MOV A,PSWC8 DEC R0C9 DEC R1CA DEC R2CB DEC R3CC DEC R4CD DEC R5CE DEC R6CF DEC R7D0 XRL A,@R0D1 XRL A,@R1D2 JB6 2D3 XRL A,#data 2D4 CALL 6 2D5 SEL RB1D6*D7 MOV PSW,AD8 XRL A,R0D9 XRL A,R1DA XRL A,R2DB XRL A,R3DC XRL A,R4DD XRL A,R5DE XRL A,R6DF XRL A,R7E0*E1*E2*E3 MOVP3 A,@AE4 JMP 7 2E5 SEL MB0E6 JNC 2E7 RL AE8 DJNZ R0 2   [Decrement and Jump if Not Zero..... nice!]E9 DJNZ R1 2EA DJNZ R2 2EB DJNZ R3 2EC DJNZ R4 2ED DJNZ R5 2EE DJNZ R6 2EF DJNZ R7 2F0 MOV A,@R0F1 MOV A,@R1F2 JB7 2F3*F4 CALL 7 2F5 SEL MB1F6 JC 2 2F7 RLC AF8 MOV A,R0F9 MOV A,R1FA MOV A,R2FB MOV A,R3FC MOV A,R4FD MOV A,R5FE MOV A,R6FF MOV A,R7VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV