0100 ;*******************************0110 ;0120 ; C-KEY0130 ;    a control key utility0140 ;    for all Atari 8-bits0150 ;0160 ; v1.5 06-10-91  by Doug Wokoun0170 ;0171 ; Program and source code is0172 ; Copyright 1991 by Doug Wokoun0173 ; See READ.ME file for0174 ; conditions0175 ;0180 ;*******************************0190 ;0200 ; Equates0210 DOSINI = $0C    ; reset key vec0220 BRKKEY = $11    ; break key flag0230 RTCLOK = $12    ; real-time clock0240 ATRACT = $4D    ; attract timer0250 VKEYBD = $0208  ; keyboard vector0260 SDMCTL = $022F  ; DMA control0270 MEMLO = $02E7   ; bottom of memory0280 CRSINH = $02F0  ; cursor inhibit0290 SSFLAG = $02FF  ; [un]lock output0300 ICHID = $0340   ; device ID0310 ICCOM = $0342   ; command byte0320 ICBAL = $0344   ; filename address0330 ICBAH = $03450340 ICBLL = $0348   ; transfer length0350 ICAX1 = $034A   ; auxiliary byte 10360 CONSOL = $D01F  ; console buttons0370 AUDF1 = $D200   ; frequency 10380 AUDC1 = $D201   ; control 10390 AUDCTL = $D208  ; audio control0400 KBCODE = $D209  ; keyboard code0410 SKCTL = $D20F   ; serial port ctl0420 CIOV =  $E456   ; CIO vector0430 COLDSV = $E477  ; cold start vec0440 ;0450     *=  $38000460 ;0470 ; Print the program identification0480 ; message always0490 ;0500     LDX #0      ; channel 00510     LDA #9      ; put text command0520     STA ICCOM0530     LDA # <MSG  ; message address0540     STA ICBAL0550     LDA # >MSG0560     STA ICBAH0570     LDA #255    ; message length0580     STA ICBLL   ;  (overkill)0590     JSR CIOV    ; print it0600 ;0610 ; Now to check to see if the0620 ; program is already installed0630 ; so we don't have a bunch of0640 ; copies in memory...to do this0650 ; we'll use the very accurate0660 ; method of sampling one byte0670 ; of code0680 ;0690     LDA VKEYBD  ; get address of0700     STA 203     ;  current key0710     LDA VKEYBD+1 ;  routine0720     STA 2040730     LDY #5      ; check 6th byte0740     LDA (203),Y0750     CMP #2      ; from 'AND #2'0760     BNE NOTINS0770 ; so I guess we can assume it's0780 ; already loaded...exit stage0790 ; right...0800     RTS 0810 ; in case it isn't loaded...0820 NOTINS0830 ; Plug values into program...0840     CLC 0850     LDA MEMLO0860     STA $CB0870     STA DOSINIT+240880     ADC #DOSINIT-START0890     STA DOSINIT+40900     STA INSTALL+10910     LDA MEMLO+10920     STA $CC0930     STA DOSINIT+290940     ADC #00950     STA DOSINIT+80960     STA INSTALL+20970     LDA DOSINI0980     STA DOSINIT+10990     LDA DOSINI+11000     STA DOSINIT+21010 ;1020 ; An improvement over previous1030 ; versions, this one will not1040 ; crash if you do a KEY command1050 ; and then [RESET] in SpartaDOS.1060 ; When reinstalling, it always1070 ; gets the new VKEYBD address.1080 ; KEY will still disable it until1090 ; the next [RESET].  This loads1100 ; registers for reinstallation.1110 ;1120     CLC 1130     LDA MEMLO1140     ADC #VEC-START+11150     STA V1+11160     LDA MEMLO+11170     ADC #01180     STA V1+21190     LDA V1+11200     ADC #11210     STA V2+11220     LDA V1+21230     ADC #01240     STA V2+21250 ;1260 ; Now to actually move the bytes1270 ; in the program since we have1280 ; already modified it for1290 ; relocation...since this version1300 ; is larger than 255 bytes, I've1310 ; traded my quickie copier for1320 ; an industrial strength, 16-bit1330 ; version...1340 ;1350     LDY #01360     LDA # <START1370     STA $CD1380     LDA # >START1390     STA $CE1400     LDA MEMLO1410     STA $CB1420     LDA MEMLO+11430     STA $CC1440 COPY1450     LDA ($CD),Y1460     STA ($CB),Y1470     INC $CB     ; bump the regs1480     BNE C11490     INC $CC1500 C1  INC $CD1510     BNE C21520     INC $CE1530 C2  LDA $CE     ; check if done1540     CMP # >END+11550     BNE COPY1560     LDA $CD1570     CMP # <END+11580     BNE COPY1590 ;1600 ; The $cb-c register indicates1610 ; where the new MEMLO should be1620 ; so we copy that to MEMLO...1630 ;1640     LDA $CB1650     STA MEMLO1660     LDA $CC1670     STA MEMLO+11680 ;1690 ; It's finally time to install1700 ; this thing...1710 ;1720     CLC 1730     LDA INSTALL+11740     ADC #31750     STA INSTALL+11760     LDA INSTALL+21770     ADC #01780     STA INSTALL+21790 INSTALL1800     JSR $FFFF   ; install1810 ;1820 ; Now, we've gotten the thing1830 ; installed...let's let the user1840 ; know that by this exquisite1850 ; chirp sound...1860 ;1870     LDA #01880     STA AUDCTL1890     LDA #31900     STA SKCTL1910     LDA #2391920     STA AUDC11930     LDA #161940     STA AUDF11950     LDA RTCLOK+21960     ADC #31970 DELAY11980     CMP RTCLOK+21990     BNE DELAY12000     LDA #122010     STA AUDF12020     LDA RTCLOK+22030     ADC #32040 DELAY22050     CMP RTCLOK+22060     BNE DELAY22070     LDA #02080     STA AUDC12090     RTS 2100 MSG2110     .BYTE "íٺv1.5 06/10/91 by Doug Wokoun",1552120 ;2130 ;*******************************2140 ;2150 ; C-KEY2160 ;    keypress routine2170 ;2180 ;*******************************2190 ;2200     *=  $40002210 ; Will be relocated above MEMLO2220 ;2230 START2240     NOP 2250     LDA CONSOL  ; check [SELECT]2260     AND #22270     BEQ VEC2280     LDA KBCODE2290     CMP #190    ; ^S pressed?2300     BNE NEXT12310     LDA #2552320     STA SSFLAG  ; stop screen2330     BMI EXIT2340 NEXT12350     CMP #175    ; ^Q pressed?2360     BNE NEXT22370     LDA #02380     STA SSFLAG  ; unstop screen2390     BEQ EXIT2400 NEXT22410     CMP #146    ; ^C pressed?2420     BNE NEXT32430 ;2440 ; Simulate the OS break key2450 ; routine...by coding this massive2460 ; routine here, the program works2470 ; on 400/800 computers, which it2480 ; wouldn't do if I used the2490 ; vector at 566-72500 ;2510     LDA #02520     STA BRKKEY2530     STA SSFLAG2540     STA CRSINH2550     STA ATRACT2560     PLA 2570     RTI         ; end processing2580 NEXT32590     CMP #254    ; SHIFT ^S?2600     BNE NEXT42610 ;2620 ; To disable the screen simply,2630 ; I just flip the "standard2640 ; playfield" bit in SDMCTL.  This2650 ; should work fine in most cases,2660 ; but if a narrow or wide screen2670 ; is used, it won't quite work.2680 ;2690     LDA SDMCTL2700     EOR #22710     STA SDMCTL2720     CLC 2730     BCC EXIT2740 NEXT42750     CMP #232    ; SHIFT ^R?2760     BNE NEXT52770     JMP COLDSV  ; jump to reboot2780 NEXT52790     CMP #202    ; SHIFT ^P?2800     BEQ PRSCR   ; print screen2810 ;2820 ; If we get here, the user has2830 ; pressed a key that this routine2840 ; doesn't process, so we send that2850 ; to the keypress routine we stole2860 ; the VKEYBD vector from...2870 ;2880 VEC JMP $FFFF2890 ; We get here if the keypress was2900 ; processed by the program.  Since2910 ; we don't want the _real_ key2920 ; routine to get the keypress, we2930 ; exit the interrupt here...2940 EXIT2950     PLA 2960     RTI 2970 ;2980 ; This is the routine to print2990 ; the screen in mode 03000 ;3010 PRSCR3020 ;3030 ; First, check to make sure we3040 ; are in mode 0, otherwise we3050 ; can't do this.3060 ;3070     LDA 87      ; DINDEX3080     BNE EXIT3090     LDA 123     ; SWPFLG3100     BMI EXIT3110 ;3120 ; To make sure we don't crash3130 ; the system, we have to store3140 ; the system registers...3150 ;3160     CLI 3170     TXA         ; hold registers3180     PHA 3190     TYA 3200     PHA 3210 ;3220 ; First a little setup...3230 ;3240     LDA #24     ; line count3250     STA 2033260     LDA 883270     STA 2043280     LDA 893290     STA 2053300 ;3310 ; We need a channel to use for3320 ; out output, so we'll scan3330 ; for one, and abort it we can't3340 ; find one...3350 ;3360     LDX #$703370 SCAN3380     LDA ICHID,X3390     BMI CFOUND3400     TXA 3410     SEC 3420     SBC #163430     BEQ PEXIT3440     TAX 3450     BNE SCAN3460 CFOUND3470 ;3480 ; If we've gotten here, the scan3490 ; routine found us a channel, and3500 ; put it in the X register, so3510 ; now we're ready to begin...3520 ; -Open channel3530     LDA #$1A    ; theres's a 'P'3540     STA ICBAL,X ;  at $031A3550     LDA #$033560     STA ICBAH,X3570     STA ICCOM,X3580     LDA #8      ; output mode3590     STA ICAX1,X3600     JSR CIOV3610     CPY #1      ; error?3620     BNE PEXIT   ; then just exit3630 ;3640 ; If we're here, we've managed3650 ; to successfully open an output3660 ; channel to the printer...3670 ;3680 ; Now we're ready...let's output3690 ; 40 screen bytes to the printer!3700 ;3710 PRLN3720     LDY #0      ; setup first3730     LDA #11     ; put command3740     STA ICCOM,X3750 PRCH3760     LDA #03770     STA ICBLL,X3780     STA ICBLL+1,X3790     LDA (204),Y ; get byte3800     EOR #$803810     STA (204),Y ; video feedback3820 ; Now we have to convert the3830 ; ICODE value to ATASCII3840     AND #$7F    ; clear inverse3850     CMP #963860     BCS P23870     CMP #643880     BCS P13890     ADC #323900     BCC P23910 P1  SBC #643920 P23930 ; Now we have the ATASCII, and3940 ; we output the thing3950 ;3960     STY 2063970     JSR CIOV3980     CPY #23990     LDY 2064000     LDA (204),Y ; restore4010     EOR #$804020     STA (204),Y4030 ;4040 ; Check for error...4050 ;4060     BCS PRDONE4070 ;4080 ; Next byte...4090     INY 4100     CPY #404110     BNE PRCH4120 ;4130 ; Now we have to append a CR4140 ; to the end of it...4150 ;4160     LDA #1554170     JSR CIOV4180 ;4190 ; Now we check to see if we need4200 ; to do more lines...4210 ;4220     DEC 2034230     BEQ PRDONE4240 ;4250 ; Guess this means we have to go4260 ; back around another time...4270 ;4280     CLC 4290     LDA 2044300     ADC #404310     STA 2044320     LDA 2054330     ADC #04340     STA 2054350     BCC PRLN4360 PRDONE4370 ; Here we are at the end...So4380 ; we have to close the channel4390 ; and relinquish control4400 ;4410     LDA #12     ; close command4420     STA ICCOM,X4430     JSR CIOV4440 PEXIT4450     PLA         ; restore regs4460     TAY 4470     PLA 4480     TAX 4490     PLA         ; exit4500     RTI 4510 ;4520 ; This routine replaces the key4530 ; routine after a system reset4540 ; displaces it.4550 ;4560 DOSINIT4570     JSR $FFFF4580     LDA #04590     STA DOSINI4600     LDA #04610     STA DOSINI+14620     LDA VKEYBD4630 V1  STA $FFFF4640     LDA VKEYBD+14650 V2  STA $FFFF4660     LDA #04670     STA VKEYBD4680     LDA #04690     STA VKEYBD+14700     RTS 4710 END4720 ;4730     *=  $02E04740     .WORD $3800